        subroutine getmet(sqrtming_np1,gtt_np1,gtx_np1,gty_np1,
     &                  gtz_np1,gxx_np1,gxy_np1,gxz_np1,gyy_np1,
     &                  gyz_np1,gzz_np1,FF_np1,
     &                  sqrtming_n,gtt_n,gtx_n,gty_n,
     &                  gtz_n,gxx_n,gxy_n,gxz_n,gyy_n,
     &                  gyz_n,gzz_n,FF_n,x,y,z);
        implicit none
        real*8 sqrtming_np1,gtt_np1,gtx_np1,gty_np1,gtz_np1,gxx_np1,
     &                  gxy_np1,gxz_np1,gyy_np1,gyz_np1,gzz_np1,FF_np1
        real*8 sqrtming_n,gtt_n,gtx_n,gty_n,gtz_n,gxx_n,
     &                  gxy_n,gxz_n,gyy_n,gyz_n,gzz_n,FF_n 
        real*8 x,y,z
        real*8 pi
        pi = 3.1415926535897932384626433832795028841971693993751058d0

        sqrtming_np1 = 1 
        gtt_np1 = -1
        gtx_np1 = 0
        gty_np1 = 0                            
        gtz_np1 = 0
        gxx_np1 = 1
        gxy_np1 = 0
        gxz_np1 = 0
        gyy_np1 = 1
        gyz_np1 = 0
        gzz_np1 = 1
        FF_np1 = 0

        sqrtming_n =1 
        gtt_n = -1
        gtx_n = 0
        gty_n = 0                            
        gtz_n = 0
        gxx_n = 1
        gxy_n = 0
        gxz_n = 0
        gyy_n = 1
        gyz_n = 0
        gzz_n = 1
        FF_n = 0

        return
        end


        subroutine getmetMinkComp(sqrtming_np1,gtt_np1,gtx_np1,gty_np1,
     &                  gtz_np1,gxx_np1,gxy_np1,gxz_np1,gyy_np1,
     &                  gyz_np1,gzz_np1,FF_np1,
     &                  sqrtming_n,gtt_n,gtx_n,gty_n,
     &                  gtz_n,gxx_n,gxy_n,gxz_n,gyy_n,
     &                  gyz_n,gzz_n,FF_n,x,y,z);
        implicit none
        real*8 sqrtming_np1,gtt_np1,gtx_np1,gty_np1,gtz_np1,gxx_np1,
     &                  gxy_np1,gxz_np1,gyy_np1,gyz_np1,gzz_np1,FF_np1
        real*8 sqrtming_n,gtt_n,gtx_n,gty_n,gtz_n,gxx_n,
     &                  gxy_n,gxz_n,gyy_n,gyz_n,gzz_n,FF_n 
        real*8 x,y,z
        real*8 pi
        pi = 3.1415926535897932384626433832795028841971693993751058d0

        sqrtming_np1 = (8/(pi**3))* ( ( cos(pi*x/2) )**2) 
     &         * ( ( cos(pi*y/2) )**2)  * ( ( cos(pi*z/2) )**2) 
        gtt_np1 = -1
        gtx_np1 = 0
        gty_np1 = 0                            
        gtz_np1 = 0
        gxx_np1 = (4/(pi**2)) * ( ( cos(pi*x/2) )**4)
        gxy_np1 = 0
        gxz_np1 = 0
        gyy_np1 = (4/(pi**2)) * ( ( cos(pi*y/2) )**4)
        gyz_np1 = 0
        gzz_np1 = (4/(pi**2)) * ( ( cos(pi*z/2) )**4)
        FF_np1 = 0

        sqrtming_n =(8/(pi**3))* ( ( cos(pi*x/2) )**2) 
     &         * ( ( cos(pi*y/2) )**2)  * ( ( cos(pi*z/2) )**2) 
        gtt_n = -1
        gtx_n = 0
        gty_n = 0                            
        gtz_n = 0
        gxx_n = (4/(pi**2)) * ( ( cos(pi*x/2) )**4)
        gxy_n = 0
        gxz_n = 0
        gyy_n = (4/(pi**2)) * ( ( cos(pi*y/2) )**4)
        gyz_n = 0
        gzz_n = (4/(pi**2)) * ( ( cos(pi*z/2) )**4)
        FF_n = 0

        return
        end

