        integer nx, ny, nz, i, j, k

        real*8 sqrtming_np1,gtt_np1,gtx_np1,gty_np1,gtz_np1,gxx_np1,
     &                  gxy_np1,gxz_np1,gyy_np1,gyz_np1,gzz_np1,FF_np1
        real*8 sqrtming_n,gtt_n,gtx_n,gty_n,gtz_n,gxx_n,
     &                  gxy_n,gxz_n,gyy_n,gyz_n,gzz_n,FF_n 

        real*8 sqrtming_pcc_np1,gtt_pcc_np1,gtx_pcc_np1,gty_pcc_np1,
     &         gtz_pcc_np1,gxx_pcc_np1,gxy_pcc_np1,gxz_pcc_np1,
     &         gyy_pcc_np1,gyz_pcc_np1,gzz_pcc_np1,FF_pcc_np1
        real*8 sqrtming_pcc_n,gtt_pcc_n,gtx_pcc_n,gty_pcc_n,
     &         gtz_pcc_n,gxx_pcc_n,gxy_pcc_n,gxz_pcc_n,
     &         gyy_pcc_n,gyz_pcc_n,gzz_pcc_n,FF_pcc_n

        real*8 sqrtming_ncc_np1,gtt_ncc_np1,gtx_ncc_np1,gty_ncc_np1,
     &         gtz_ncc_np1,gxx_ncc_np1,gxy_ncc_np1,gxz_ncc_np1,
     &         gyy_ncc_np1,gyz_ncc_np1,gzz_ncc_np1,FF_ncc_np1
        real*8 sqrtming_ncc_n,gtt_ncc_n,gtx_ncc_n,gty_ncc_n,
     &         gtz_ncc_n,gxx_ncc_n,gxy_ncc_n,gxz_ncc_n,
     &         gyy_ncc_n,gyz_ncc_n,gzz_ncc_n,FF_ncc_n

        real*8 sqrtming_cpc_np1,gtt_cpc_np1,gtx_cpc_np1,gty_cpc_np1,
     &         gtz_cpc_np1,gxx_cpc_np1,gxy_cpc_np1,gxz_cpc_np1,
     &         gyy_cpc_np1,gyz_cpc_np1,gzz_cpc_np1,FF_cpc_np1
        real*8 sqrtming_cpc_n,gtt_cpc_n,gtx_cpc_n,gty_cpc_n,
     &         gtz_cpc_n,gxx_cpc_n,gxy_cpc_n,gxz_cpc_n,
     &         gyy_cpc_n,gyz_cpc_n,gzz_cpc_n,FF_cpc_n

        real*8 sqrtming_cnc_np1,gtt_cnc_np1,gtx_cnc_np1,gty_cnc_np1,
     &         gtz_cnc_np1,gxx_cnc_np1,gxy_cnc_np1,gxz_cnc_np1,
     &         gyy_cnc_np1,gyz_cnc_np1,gzz_cnc_np1,FF_cnc_np1
        real*8 sqrtming_cnc_n,gtt_cnc_n,gtx_cnc_n,gty_cnc_n,
     &         gtz_cnc_n,gxx_cnc_n,gxy_cnc_n,gxz_cnc_n,
     &         gyy_cnc_n,gyz_cnc_n,gzz_cnc_n,FF_cnc_n

        real*8 sqrtming_ccp_np1,gtt_ccp_np1,gtx_ccp_np1,gty_ccp_np1,
     &         gtz_ccp_np1,gxx_ccp_np1,gxy_ccp_np1,gxz_ccp_np1,
     &         gyy_ccp_np1,gyz_ccp_np1,gzz_ccp_np1,FF_ccp_np1
        real*8 sqrtming_ccp_n,gtt_ccp_n,gtx_ccp_n,gty_ccp_n,
     &         gtz_ccp_n,gxx_ccp_n,gxy_ccp_n,gxz_ccp_n,
     &         gyy_ccp_n,gyz_ccp_n,gzz_ccp_n,FF_ccp_n

        real*8 sqrtming_ccn_np1,gtt_ccn_np1,gtx_ccn_np1,gty_ccn_np1,
     &         gtz_ccn_np1,gxx_ccn_np1,gxy_ccn_np1,gxz_ccn_np1,
     &         gyy_ccn_np1,gyz_ccn_np1,gzz_ccn_np1,FF_ccn_np1
        real*8 sqrtming_ccn_n,gtt_ccn_n,gtx_ccn_n,gty_ccn_n,
     &         gtz_ccn_n,gxx_ccn_n,gxy_ccn_n,gxz_ccn_n,
     &         gyy_ccn_n,gyz_ccn_n,gzz_ccn_n,FF_ccn_n


       nx = g1_nx
       ny = g1_ny
       nz = g1_nz



       do i=2, g1_Nx-1, 1
       do j=2, g1_Ny-1, 1
       do k=2, g1_Nz-1, 1

c The following calls get the metric at various coordinates. For 
c instance, pcc is (i+1,j,k), cnc is (i,j-1,k), etc. The metric is then
c used to compute derivatives numerically.

       call getmet(sqrtming_pcc_np1,gtt_pcc_np1,gtx_pcc_np1,gty_pcc_np1,
     &              gtz_pcc_np1,gxx_pcc_np1,gxy_pcc_np1,gxz_pcc_np1,
     &              gyy_pcc_np1,gyz_pcc_np1,gzz_pcc_np1,FF_pcc_np1,
     &              sqrtming_pcc_n,gtt_pcc_n,gtx_pcc_n,gty_pcc_n,
     &              gtz_pcc_n,gxx_pcc_n,gxy_pcc_n,gxz_pcc_n,gyy_pcc_n,
     &              gyz_pcc_n,gzz_pcc_n,FF_pcc_n,x(i+1),y(j),z(k));

       call getmet(sqrtming_ncc_np1,gtt_ncc_np1,gtx_ncc_np1,gty_ncc_np1,
     &              gtz_ncc_np1,gxx_ncc_np1,gxy_ncc_np1,gxz_ncc_np1,
     &              gyy_ncc_np1,gyz_ncc_np1,gzz_ncc_np1,FF_ncc_np1,
     &              sqrtming_ncc_n,gtt_ncc_n,gtx_ncc_n,gty_ncc_n,
     &              gtz_ncc_n,gxx_ncc_n,gxy_ncc_n,gxz_ncc_n,gyy_ncc_n,
     &              gyz_ncc_n,gzz_ncc_n,FF_ncc_n,x(i-1),y(j),z(k));

       call getmet(sqrtming_cpc_np1,gtt_cpc_np1,gtx_cpc_np1,gty_cpc_np1,
     &              gtz_cpc_np1,gxx_cpc_np1,gxy_cpc_np1,gxz_cpc_np1,
     &              gyy_cpc_np1,gyz_cpc_np1,gzz_cpc_np1,FF_cpc_np1,
     &              sqrtming_cpc_n,gtt_cpc_n,gtx_cpc_n,gty_cpc_n,
     &              gtz_cpc_n,gxx_cpc_n,gxy_cpc_n,gxz_cpc_n,gyy_cpc_n,
     &              gyz_cpc_n,gzz_cpc_n,FF_cpc_n,x(i),y(j+1),z(k));

       call getmet(sqrtming_cnc_np1,gtt_cnc_np1,gtx_cnc_np1,gty_cnc_np1,
     &              gtz_cnc_np1,gxx_cnc_np1,gxy_cnc_np1,gxz_cnc_np1,
     &              gyy_cnc_np1,gyz_cnc_np1,gzz_cnc_np1,FF_cnc_np1,
     &              sqrtming_cnc_n,gtt_cnc_n,gtx_cnc_n,gty_cnc_n,
     &              gtz_cnc_n,gxx_cnc_n,gxy_cnc_n,gxz_cnc_n,gyy_cnc_n,
     &              gyz_cnc_n,gzz_cnc_n,FF_cnc_n,x(i),y(j-1),z(k));

       call getmet(sqrtming_ccp_np1,gtt_ccp_np1,gtx_ccp_np1,gty_ccp_np1,
     &              gtz_ccp_np1,gxx_ccp_np1,gxy_ccp_np1,gxz_ccp_np1,
     &              gyy_ccp_np1,gyz_ccp_np1,gzz_ccp_np1,FF_ccp_np1,
     &              sqrtming_ccp_n,gtt_ccp_n,gtx_ccp_n,gty_ccp_n,
     &              gtz_ccp_n,gxx_ccp_n,gxy_ccp_n,gxz_ccp_n,gyy_ccp_n,
     &              gyz_ccp_n,gzz_ccp_n,FF_ccp_n,x(i),y(j),z(k+1));

       call getmet(sqrtming_ccn_np1,gtt_ccn_np1,gtx_ccn_np1,gty_ccn_np1,
     &              gtz_ccn_np1,gxx_ccn_np1,gxy_ccn_np1,gxz_ccn_np1,
     &              gyy_ccn_np1,gyz_ccn_np1,gzz_ccn_np1,FF_ccn_np1,
     &              sqrtming_ccn_n,gtt_ccn_n,gtx_ccn_n,gty_ccn_n,
     &              gtz_ccn_n,gxx_ccn_n,gxy_ccn_n,gxz_ccn_n,gyy_ccn_n,
     &              gyz_ccn_n,gzz_ccn_n,FF_ccn_n,x(i),y(j),z(k-1));

        call getmet(sqrtming_np1,gtt_np1,gtx_np1,gty_np1,
     &              gtz_np1,gxx_np1,gxy_np1,gxz_np1,gyy_np1,
     &              gyz_np1,gzz_np1,FF_np1,
     &              sqrtming_n,gtt_n,gtx_n,gty_n,
     &              gtz_n,gxx_n,gxy_n,gxz_n,gyy_n,
     &              gyz_n,gzz_n,FF_n,x(i),y(j),z(k));


c This update formula for mu is quite long. It consists of 7 terms
c  (T1 thru T7, given in the documentaion), each with 2 time levels 
c  (_n and _np1). Because T1 contains a time derivative of sqrtming, 
c both the _np1 and the _n time levels have been written at the 
c beginning. For all other time levels first all _np1 time levels
c appear, then all _n time levels, since the _n time levels are 
c obtained from the _np1 time levels by copy-pasting and replacing 
c _np1 with _n everywhere. The order is thus T1,T2_np1,T3_np1,T4_np1,
c T5_np1,T6_np1,T7_np1,T2_n,T3_n,T4_n,T5_n,T6_n,T7_n.


        RHSphi_n(i,j,k) = - (
     &    mu_np1(i,j,k)/gtt_np1 
     &  + gtx_np1*(phi_np1(i+1,j,k)-phi_np1(i-1,j,k))/(2*dx*gtt_np1) 
     &  + gty_np1*(phi_np1(i,j+1,k)-phi_np1(i,j-1,k))/(2*dy*gtt_np1) 
     &  + gtz_np1*(phi_np1(i,j,k+1)-phi_np1(i,j,k-1))/(2*dz*gtt_np1) 
     &  + mu_n(i,j,k)/gtt_n 
     &  + gtx_n*(phi_n(i+1,j,k)-phi_n(i-1,j,k))/(2*dx*gtt_n) 
     &  + gty_n*(phi_n(i,j+1,k)-phi_n(i,j-1,k))/(2*dy*gtt_n) 
     &  + gtz_n*(phi_n(i,j,k+1)-phi_n(i,j,k-1))/(2*dz*gtt_n) )/2;
       
                     
        RHSmu_n(i,j,k) = 
c    T1_np1:
     &  - ( mu_np1(i,j,k)/sqrtming_np1 + mu_n(i,j,k)/sqrtming_n )
     &  * (sqrtming_np1 - sqrtming_n)/(2*dt) + (
c    T2_np1:
     &  -FF_np1
c    T3_np1:
     &  +(sqrtming_pcc_np1*gxx_pcc_np1 - sqrtming_ncc_np1*gxx_ncc_np1)*
     &   (phi_np1(i+1,j,k) - phi_np1(i-1,j,k) )/(4*sqrtming_np1*dx*dx)
     &  +(sqrtming_cpc_np1*gxy_cpc_np1 - sqrtming_cnc_np1*gxy_cnc_np1)*
     &   (phi_np1(i+1,j,k) - phi_np1(i-1,j,k) )/(4*sqrtming_np1*dx*dy)
     &  +(sqrtming_ccp_np1*gxz_ccp_np1 - sqrtming_ccn_np1*gxz_ccn_np1)*
     &   (phi_np1(i+1,j,k) - phi_np1(i-1,j,k) )/(4*sqrtming_np1*dx*dz)

     &  +(sqrtming_pcc_np1*gxy_pcc_np1 - sqrtming_ncc_np1*gxy_ncc_np1)*
     &   (phi_np1(i,j+1,k) - phi_np1(i,j-1,k) )/(4*sqrtming_np1*dy*dx)
     &  +(sqrtming_cpc_np1*gyy_cpc_np1 - sqrtming_cnc_np1*gyy_cnc_np1)*
     &   (phi_np1(i,j+1,k) - phi_np1(i,j-1,k) )/(4*sqrtming_np1*dy*dy)
     &  +(sqrtming_ccp_np1*gyz_ccp_np1 - sqrtming_ccn_np1*gyz_ccn_np1)*
     &   (phi_np1(i,j+1,k) - phi_np1(i,j-1,k) )/(4*sqrtming_np1*dy*dz)

     &  +(sqrtming_pcc_np1*gxz_pcc_np1 - sqrtming_ncc_np1*gxz_ncc_np1)*
     &   (phi_np1(i,j,k+1) - phi_np1(i,j,k-1) )/(4*sqrtming_np1*dz*dx)
     &  +(sqrtming_cpc_np1*gyz_cpc_np1 - sqrtming_cnc_np1*gyz_cnc_np1)*
     &   (phi_np1(i,j,k+1) - phi_np1(i,j,k-1) )/(4*sqrtming_np1*dz*dy)
     &  +(sqrtming_ccp_np1*gzz_ccp_np1 - sqrtming_ccn_np1*gzz_ccn_np1)*
     &   (phi_np1(i,j,k+1) - phi_np1(i,j,k-1) )/(4*sqrtming_np1*dz*dz)
c    T4_np1:
     &  +gxx_np1*(phi_np1(i+1,j,k)-2*phi_np1(i,j,k)+phi_np1(i-1,j,k))/
     &   (dx*dx) 

     &  +gxy_np1*( phi_np1(i+1,j+1,k) - phi_np1(i+1,j-1,k) - 
     &   phi_np1(i-1,j+1,k) + phi_np1(i-1,j-1,k)  )/(2*dx*dy)

     &  +gxz_np1*( phi_np1(i+1,j,k+1) - phi_np1(i+1,j,k-1) - 
     &   phi_np1(i-1,j,k+1) + phi_np1(i-1,j,k-1)  )/(2*dx*dz)
 
     &  +gyy_np1*(phi_np1(i,j+1,k)-2*phi_np1(i,j,k)+phi_np1(i,j-1,k))/
     &   (dy*dy)

     &  +gyz_np1*( phi_np1(i,j+1,k+1) - phi_np1(i,j+1,k-1) - 
     &   phi_np1(i,j-1,k+1) + phi_np1(i,j-1,k-1)  )/(2*dy*dz)

     &  +gzz_np1*(phi_np1(i,j,k+1)-2*phi_np1(i,j,k)+phi_np1(i,j,k-1))/
     &   (dz*dz)
c    T5_np1:
     &  -(sqrtming_pcc_np1*gtx_pcc_np1*mu_np1(i+1,j,k)/gtt_pcc_np1 - 
     &    sqrtming_ncc_np1*gtx_ncc_np1*mu_np1(i-1,j,k)/gtt_ncc_np1 )
     &    /(2*dx*sqrtming_np1)
     
     &  -(sqrtming_cpc_np1*gty_cpc_np1*mu_np1(i,j+1,k)/gtt_cpc_np1 - 
     &    sqrtming_cnc_np1*gty_cnc_np1*mu_np1(i,j-1,k)/gtt_cnc_np1 )
     &    /(2*dy*sqrtming_np1)

     &  -(sqrtming_ccp_np1*gtz_ccp_np1*mu_np1(i,j,k+1)/gtt_ccp_np1 - 
     &    sqrtming_ccn_np1*gtz_ccn_np1*mu_np1(i,j,k-1)/gtt_ccn_np1 )
     &    /(2*dz*sqrtming_np1)
c    T6_np1:
     &  -(sqrtming_pcc_np1*gtx_pcc_np1*gtx_pcc_np1/gtt_pcc_np1 - 
     &    sqrtming_ncc_np1*gtx_ncc_np1*gtx_ncc_np1/gtt_ncc_np1 )*
     &   ( phi_np1(i+1,j,k)-phi_np1(i-1,j,k) )/(4*sqrtming_np1*dx*dx)
     &  -(sqrtming_cpc_np1*gty_cpc_np1*gtx_cpc_np1/gtt_cpc_np1 - 
     &    sqrtming_cnc_np1*gty_cnc_np1*gtx_cnc_np1/gtt_cnc_np1 )*
     &   ( phi_np1(i+1,j,k)-phi_np1(i-1,j,k) )/(4*sqrtming_np1*dx*dy)
     &  -(sqrtming_ccp_np1*gtz_ccp_np1*gtx_ccp_np1/gtt_ccp_np1 - 
     &    sqrtming_ccn_np1*gtz_ccn_np1*gtx_ccn_np1/gtt_ccn_np1 )*
     &   ( phi_np1(i+1,j,k)-phi_np1(i-1,j,k) )/(4*sqrtming_np1*dx*dz)

     &  -(sqrtming_pcc_np1*gtx_pcc_np1*gty_pcc_np1/gtt_pcc_np1 - 
     &    sqrtming_ncc_np1*gtx_ncc_np1*gty_ncc_np1/gtt_ncc_np1 )*
     &   ( phi_np1(i,j+1,k)-phi_np1(i,j-1,k) )/(4*sqrtming_np1*dy*dx)
     &  -(sqrtming_cpc_np1*gty_cpc_np1*gty_cpc_np1/gtt_cpc_np1 - 
     &    sqrtming_cnc_np1*gty_cnc_np1*gty_cnc_np1/gtt_cnc_np1 )*
     &   ( phi_np1(i,j+1,k)-phi_np1(i,j-1,k) )/(4*sqrtming_np1*dy*dy)
     &  -(sqrtming_ccp_np1*gtz_ccp_np1*gty_ccp_np1/gtt_ccp_np1 - 
     &    sqrtming_ccn_np1*gtz_ccn_np1*gty_ccn_np1/gtt_ccn_np1 )*
     &   ( phi_np1(i,j+1,k)-phi_np1(i,j-1,k) )/(4*sqrtming_np1*dy*dz)

     &  -(sqrtming_pcc_np1*gtx_pcc_np1*gtz_pcc_np1/gtt_pcc_np1 - 
     &    sqrtming_ncc_np1*gtx_ncc_np1*gtz_ncc_np1/gtt_ncc_np1 )*
     &   ( phi_np1(i,j,k+1)-phi_np1(i,j,k-1) )/(4*sqrtming_np1*dz*dx)
     &  -(sqrtming_cpc_np1*gty_cpc_np1*gtz_cpc_np1/gtt_cpc_np1 - 
     &    sqrtming_cnc_np1*gty_cnc_np1*gtz_cnc_np1/gtt_cnc_np1 )*
     &   ( phi_np1(i,j,k+1)-phi_np1(i,j,k-1) )/(4*sqrtming_np1*dz*dy)
     &  -(sqrtming_ccp_np1*gtz_ccp_np1*gtz_ccp_np1/gtt_ccp_np1 - 
     &    sqrtming_ccn_np1*gtz_ccn_np1*gtz_ccn_np1/gtt_ccn_np1 )*
     &   ( phi_np1(i,j,k+1)-phi_np1(i,j,k-1) )/(4*sqrtming_np1*dz*dz)
c    T7_np1:
     &  -gtx_np1*gtx_np1*(phi_np1(i+1,j,k)-2*phi_np1(i,j,k)+
     &   phi_np1(i-1,j,k))/(dx*dx*gtt_np1) 

     &  -gtx_np1*gty_np1*(phi_np1(i+1,j+1,k)-phi_np1(i+1,j-1,k)- 
     &   phi_np1(i-1,j+1,k)+phi_np1(i-1,j-1,k))/(2*dx*dy*gtt_np1)

     &  -gtx_np1*gtz_np1*(phi_np1(i+1,j,k+1)-phi_np1(i+1,j,k-1)- 
     &   phi_np1(i-1,j,k+1)+phi_np1(i-1,j,k-1))/(2*dx*dz*gtt_np1)

     &  -gty_np1*gty_np1*(phi_np1(i,j+1,k)-2*phi_np1(i,j,k)+
     &   phi_np1(i,j-1,k))/(dy*dy*gtt_np1) 

     &  -gty_np1*gtz_np1*(phi_np1(i,j+1,k+1)-phi_np1(i,j+1,k-1)- 
     &   phi_np1(i,j-1,k+1)+phi_np1(i,j-1,k-1))/(2*dy*dz*gtt_np1)  
 
     &  -gtz_np1*gtz_np1*(phi_np1(i,j,k+1)-2*phi_np1(i,j,k)+
     &   phi_np1(i,j,k-1))/(dz*dz*gtt_np1) 

c    NOW COMES THE PAST TIME LEVEL:
c    T2_n:
     &  -FF_n
c    T3_n:
     &  +(sqrtming_pcc_n*gxx_pcc_n - sqrtming_ncc_n*gxx_ncc_n)*
     &   (phi_n(i+1,j,k) - phi_n(i-1,j,k) )/(4*sqrtming_n*dx*dx)
     &  +(sqrtming_cpc_n*gxy_cpc_n - sqrtming_cnc_n*gxy_cnc_n)*
     &   (phi_n(i+1,j,k) - phi_n(i-1,j,k) )/(4*sqrtming_n*dx*dy)
     &  +(sqrtming_ccp_n*gxz_ccp_n - sqrtming_ccn_n*gxz_ccn_n)*
     &   (phi_n(i+1,j,k) - phi_n(i-1,j,k) )/(4*sqrtming_n*dx*dz)

     &  +(sqrtming_pcc_n*gxy_pcc_n - sqrtming_ncc_n*gxy_ncc_n)*
     &   (phi_n(i,j+1,k) - phi_n(i,j-1,k) )/(4*sqrtming_n*dy*dx)
     &  +(sqrtming_cpc_n*gyy_cpc_n - sqrtming_cnc_n*gyy_cnc_n)*
     &   (phi_n(i,j+1,k) - phi_n(i,j-1,k) )/(4*sqrtming_n*dy*dy)
     &  +(sqrtming_ccp_n*gyz_ccp_n - sqrtming_ccn_n*gyz_ccn_n)*
     &   (phi_n(i,j+1,k) - phi_n(i,j-1,k) )/(4*sqrtming_n*dy*dz)

     &  +(sqrtming_pcc_n*gxz_pcc_n - sqrtming_ncc_n*gxz_ncc_n)*
     &   (phi_n(i,j,k+1) - phi_n(i,j,k-1) )/(4*sqrtming_n*dz*dx)
     &  +(sqrtming_cpc_n*gyz_cpc_n - sqrtming_cnc_n*gyz_cnc_n)*
     &   (phi_n(i,j,k+1) - phi_n(i,j,k-1) )/(4*sqrtming_n*dz*dy)
     &  +(sqrtming_ccp_n*gzz_ccp_n - sqrtming_ccn_n*gzz_ccn_n)*
     &   (phi_n(i,j,k+1) - phi_n(i,j,k-1) )/(4*sqrtming_n*dz*dz)
c    T4_n:
     &  +gxx_n*(phi_n(i+1,j,k)-2*phi_n(i,j,k)+phi_n(i-1,j,k))/
     &   (dx*dx) 

     &  +gxy_n*( phi_n(i+1,j+1,k) - phi_n(i+1,j-1,k) - 
     &   phi_n(i-1,j+1,k) + phi_n(i-1,j-1,k)  )/(2*dx*dy)

     &  +gxz_n*( phi_n(i+1,j,k+1) - phi_n(i+1,j,k-1) - 
     &   phi_n(i-1,j,k+1) + phi_n(i-1,j,k-1)  )/(2*dx*dz)
 
     &  +gyy_n*(phi_n(i,j+1,k)-2*phi_n(i,j,k)+phi_n(i,j-1,k))/
     &   (dy*dy)

     &  +gyz_n*( phi_n(i,j+1,k+1) - phi_n(i,j+1,k-1) - 
     &   phi_n(i,j-1,k+1) + phi_n(i,j-1,k-1)  )/(2*dy*dz)

     &  +gzz_n*(phi_n(i,j,k+1)-2*phi_n(i,j,k)+phi_n(i,j,k-1))/
     &   (dz*dz)
c    T5_n:
     &  -(sqrtming_pcc_n*gtx_pcc_n*mu_n(i+1,j,k)/gtt_pcc_n - 
     &    sqrtming_ncc_n*gtx_ncc_n*mu_n(i-1,j,k)/gtt_ncc_n )
     &    /(2*dx*sqrtming_n)
     
     &  -(sqrtming_cpc_n*gty_cpc_n*mu_n(i,j+1,k)/gtt_cpc_n - 
     &    sqrtming_cnc_n*gty_cnc_n*mu_n(i,j-1,k)/gtt_cnc_n )
     &    /(2*dy*sqrtming_n)

     &  -(sqrtming_ccp_n*gtz_ccp_n*mu_n(i,j,k+1)/gtt_ccp_n - 
     &    sqrtming_ccn_n*gtz_ccn_n*mu_n(i,j,k-1)/gtt_ccn_n )
     &    /(2*dz*sqrtming_n)
c    T6_n:
     &  -(sqrtming_pcc_n*gtx_pcc_n*gtx_pcc_n/gtt_pcc_n - 
     &    sqrtming_ncc_n*gtx_ncc_n*gtx_ncc_n/gtt_ncc_n )*
     &   ( phi_n(i+1,j,k)-phi_n(i-1,j,k) )/(4*sqrtming_n*dx*dx)
     &  -(sqrtming_cpc_n*gty_cpc_n*gtx_cpc_n/gtt_cpc_n - 
     &    sqrtming_cnc_n*gty_cnc_n*gtx_cnc_n/gtt_cnc_n )*
     &   ( phi_n(i+1,j,k)-phi_n(i-1,j,k) )/(4*sqrtming_n*dx*dy)
     &  -(sqrtming_ccp_n*gtz_ccp_n*gtx_ccp_n/gtt_ccp_n - 
     &    sqrtming_ccn_n*gtz_ccn_n*gtx_ccn_n/gtt_ccn_n )*
     &   ( phi_n(i+1,j,k)-phi_n(i-1,j,k) )/(4*sqrtming_n*dx*dz)

     &  -(sqrtming_pcc_n*gtx_pcc_n*gty_pcc_n/gtt_pcc_n - 
     &    sqrtming_ncc_n*gtx_ncc_n*gty_ncc_n/gtt_ncc_n )*
     &   ( phi_n(i,j+1,k)-phi_n(i,j-1,k) )/(4*sqrtming_n*dy*dx)
     &  -(sqrtming_cpc_n*gty_cpc_n*gty_cpc_n/gtt_cpc_n - 
     &    sqrtming_cnc_n*gty_cnc_n*gty_cnc_n/gtt_cnc_n )*
     &   ( phi_n(i,j+1,k)-phi_n(i,j-1,k) )/(4*sqrtming_n*dy*dy)
     &  -(sqrtming_ccp_n*gtz_ccp_n*gty_ccp_n/gtt_ccp_n - 
     &    sqrtming_ccn_n*gtz_ccn_n*gty_ccn_n/gtt_ccn_n )*
     &   ( phi_n(i,j+1,k)-phi_n(i,j-1,k) )/(4*sqrtming_n*dy*dz)

     &  -(sqrtming_pcc_n*gtx_pcc_n*gtz_pcc_n/gtt_pcc_n - 
     &    sqrtming_ncc_n*gtx_ncc_n*gtz_ncc_n/gtt_ncc_n )*
     &   ( phi_n(i,j,k+1)-phi_n(i,j,k-1) )/(4*sqrtming_n*dz*dx)
     &  -(sqrtming_cpc_n*gty_cpc_n*gtz_cpc_n/gtt_cpc_n - 
     &    sqrtming_cnc_n*gty_cnc_n*gtz_cnc_n/gtt_cnc_n )*
     &   ( phi_n(i,j,k+1)-phi_n(i,j,k-1) )/(4*sqrtming_n*dz*dy)
     &  -(sqrtming_ccp_n*gtz_ccp_n*gtz_ccp_n/gtt_ccp_n - 
     &    sqrtming_ccn_n*gtz_ccn_n*gtz_ccn_n/gtt_ccn_n )*
     &   ( phi_n(i,j,k+1)-phi_n(i,j,k-1) )/(4*sqrtming_n*dz*dz)
c    T7_n:
     &  -gtx_n*gtx_n*(phi_n(i+1,j,k)-2*phi_n(i,j,k)+
     &   phi_n(i-1,j,k))/(dx*dx*gtt_n) 

     &  -gtx_n*gty_n*(phi_n(i+1,j+1,k)-phi_n(i+1,j-1,k)- 
     &   phi_n(i-1,j+1,k)+phi_n(i-1,j-1,k))/(2*dx*dy*gtt_n)

     &  -gtx_n*gtz_n*(phi_n(i+1,j,k+1)-phi_n(i+1,j,k-1)- 
     &   phi_n(i-1,j,k+1)+phi_n(i-1,j,k-1))/(2*dx*dz*gtt_n)

     &  -gty_n*gty_n*(phi_n(i,j+1,k)-2*phi_n(i,j,k)+
     &   phi_n(i,j-1,k))/(dy*dy*gtt_n) 

     &  -gty_n*gtz_n*(phi_n(i,j+1,k+1)-phi_n(i,j+1,k-1)- 
     &   phi_n(i,j-1,k+1)+phi_n(i,j-1,k-1))/(2*dy*dz*gtt_n)  
 
     &  -gtz_n*gtz_n*(phi_n(i,j,k+1)-2*phi_n(i,j,k)+
     &   phi_n(i,j,k-1))/(dz*dz*gtt_n) 

     &                                    )/2
        end do
        end do
        end do

